/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import kr.pe.kkaok.util.Function;
import kr.pe.kkaok.common.ErrException;

public class Count extends HttpServlet {
  private int year;
  private int month;
  private int nowdate;
  private int dayofweek;
  private int makeToday;
  private int hour;
  private int min;
  private int makeTime;
  private String ip;
  private String referer;
  private String UserAgent;
  private String osys;
  CountManager cm;
  
  public Count() {
    init();
  }
  
  public void init(){
    Calendar now = Calendar.getInstance();
    year      = now.get(Calendar.YEAR);
    month     = now.get(Calendar.MONTH) + 1;
    nowdate   = now.get(Calendar.DATE);
    dayofweek = now.get(Calendar.DAY_OF_WEEK);
    makeToday = (year*10000)+(month*100)+nowdate;
    hour      = now.get(Calendar.HOUR_OF_DAY);
    min       = now.get(Calendar.MINUTE);
    makeTime  = (hour*100)+min;
    cm = CountManager.getInstance();
  }        

  public synchronized void todayCount(HttpServletRequest request, 
                                      HttpServletResponse response) 
                                      throws ServletException,ErrException
  {
    HttpSession session = request.getSession();
    try{
      if(session.getAttribute("curLogin") == null || session.getAttribute("curLogin").equals("")){
        ip = request.getRemoteAddr(); 
        referer = Function.getReqParameter(request.getHeader("Referer"));
        if(referer.length() >120) referer = referer.substring(0,120);
        UserAgent = Function.getReqParameter(request.getHeader("User-Agent"),"etc");
        int trimUAStart = UserAgent.indexOf("MSIE");
        if(trimUAStart != -1) UserAgent = UserAgent.substring(trimUAStart);  
        int trimUAEnd = UserAgent.indexOf(";");
        if(trimUAEnd != -1) UserAgent = UserAgent.substring(0,trimUAEnd);  
        if(UserAgent.length() > 15) UserAgent = UserAgent.substring(0,14);
        osys = Function.getReqParameter(request.getHeader("User-Agent"),"etc");
        int trimOsStart = osys.indexOf("Windows");
        if(trimOsStart != -1) osys = osys.substring(trimOsStart);  
        int trimOsEnd = osys.indexOf(")");
        if(trimOsEnd != -1) osys = osys.substring(0,trimOsEnd);  
        int trimOsEndEtc = osys.indexOf(";");
        if(trimOsEndEtc != -1) osys = osys.substring(0,trimOsEndEtc);  
        if(osys.length() > 15) osys = osys.substring(0,14);
        plusNewCount();
        session.setMaxInactiveInterval(60*10);
        session.setAttribute("curLogin",new CustomBindingListener());
        getStatistics();
      }
    }catch(Exception ex){
      System.out.println(ex.toString());
    }
  }

  public void getStatistics() throws ServletException,ErrException
  {
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    String query = "select count(*) today from kcount where cdate = ?";
    int today = 0;
    Connection conn = null;
    try{
      conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn.prepareStatement(query);
      pstmt.setInt(1,makeToday);
      rs = pstmt.executeQuery();
      if(rs.next()){
        today = rs.getInt("today");
      }
    } catch (SQLException se) {
      throw new ErrException("Count.java","getStatistics"," ī͸ ҷ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Count.java","getStatistics"," ī͸ ҷ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception s){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception s){}  
      try{if (conn!=null) conn.close();}catch(SQLException se){}
    }

    query = "select max(idx) totalSum from kcount";
    int totalSum = 0;
    Connection conn2 = null;
    try{
      conn2 = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn2.prepareStatement(query);
      rs = pstmt.executeQuery();
      if(rs.next()){
        totalSum = rs.getInt("totalSum");
      }
    } catch (SQLException se) {
      throw new ErrException("Count.java","getStatistics","ü ī͸ ҷ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Count.java","getStatistics","ü ī͸ ҷ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception s){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception s){}  
      try{if (conn2!=null) conn2.close();}catch(SQLException se){}
    }

    cm.addCount(today,totalSum);
  }

  public synchronized void plusNewCount() throws ServletException,ErrException
  {
    PreparedStatement pstmt = null;
    String ipt_query = "insert into kcount(cdate,ctime,dayofweek,ip,referer,browser,os) values(?,?,?,?,?,?,?)";
    synchronized(this){
      Connection conn = null;
      try{
        conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
        pstmt = conn.prepareStatement(ipt_query);
        pstmt.setInt(1,makeToday);
        pstmt.setInt(2,makeTime);
        pstmt.setInt(3,dayofweek);
        pstmt.setString(4,ip);
        pstmt.setString(5,referer);
        pstmt.setString(6,UserAgent);
        pstmt.setString(7,osys);
        pstmt.executeUpdate();
      } catch (SQLException se) {
        throw new ErrException("Count.java","plusNewCount","ī   INSERT   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
      } catch (Exception e) {
        throw new ErrException("Count.java","plusNewCount","ī   INSERT   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
      }finally{
        if (pstmt!=null) try{pstmt.close();}catch(Exception s){} 
        try{if (conn!=null) conn.close();}catch(SQLException se){}
      }
    }      
  }

  public int getToday(){
    return cm.getToday();
  }  

  public int getTotalSum(){
    return cm.getTotalSum();
  }
  
  public int getACcount(){
    SessionManager sm = SessionManager.getInstance();
    return sm.getAccessClientCount();
  }
}

/*************************************
  Author      : 
  Email       : lmy20@naver.com
  homepage    : http://www.javasun.net/
  Created on  : 2002.12.05 
  Description : Ʒ ҽ  ҽ ^^ 
       :
*************************************/
class CustomBindingListener implements HttpSessionBindingListener {
  
  String loginid;
  String sessionid;
  SessionManager sm;
  CustomBindingListener(String loginid){
    this.loginid = loginid;
  }

  public CustomBindingListener(){
    loginid = "curLogin";
  }

  //ǿ  ߰ɶ ߻ϴ ̺Ʈ ޼ҵ
  public void valueBound(HttpSessionBindingEvent event) {
    HttpSession ss = event.getSession();
    sessionid = ss.getId();
    sm = SessionManager.getInstance();
    //Hashtable Ǿ̵ α ̵ մϴ.
    sm.addClient(sessionid,loginid);
  }
  //ǿ  Ҹɶ ߻ϴ ̺Ʈ ޼ҵ
  public void valueUnbound(HttpSessionBindingEvent event) {
    HttpSession ss = event.getSession();
    sessionid = ss.getId();
    sm = SessionManager.getInstance();
    //Hashtable Ǿ̵ Ű  մϴ.
    sm.removeClient(sessionid);
  }
}