/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import kr.pe.kkaok.util.Function;
import kr.pe.kkaok.common.ErrException;

public class Day extends HttpServlet {
  private int thisYear     = 0 ;
  private int thisMonth    = 0 ;
  private int startYear    = 0 ;
  private int endYear      = 0 ;
  private int startMonth   = 1 ;
  private int endMonth     = 12;
  private int SINCE_YEAR;
  private int SINCE_MONTH;
  private int NOW_YEAR;
  private int NOW_MONTH;

  public void init(ServletConfig config) throws javax.servlet.ServletException {
    super.init(config);
    ResourceBundle bundle = null;
    try {
        bundle = ResourceBundle.getBundle("URL");
        SINCE_YEAR  = Integer.parseInt(bundle.getString("SINCE_YEAR").toString());
        SINCE_MONTH = Integer.parseInt(bundle.getString("SINCE_MONTH").toString());
    } catch (Exception e) {
        System.out.println("Err: "+e.toString());
    }
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  {
    String cmd = Function.getReqParameter(request.getParameter("cmd"),"day");
    Calendar now= Calendar.getInstance();
    NOW_YEAR    = now.get(Calendar.YEAR);
    NOW_MONTH   = now.get(Calendar.MONTH) + 1;
    thisYear  = Function.getIntParameter(request.getParameter("thisYear"),NOW_YEAR);
    thisMonth = Function.getIntParameter(request.getParameter("thisMonth"),NOW_MONTH);
    now.set(thisYear,thisMonth-1,1);
    int END_DATE = now.getActualMaximum(Calendar.DATE);

    startYear = SINCE_YEAR;
    endYear   = NOW_YEAR;
    if(thisYear==startYear) startMonth=SINCE_MONTH;
    else startMonth = 1;
    if(thisYear==endYear) endMonth=NOW_MONTH;
    else endMonth = 12;

    response.setContentType("text/html; charset=EUC-KR");
    PrintWriter out   = null; 
    try{ 
      out = response.getWriter();
    }catch(IOException ie){}    

    CountHtmlForm strHtml = new CountHtmlForm();

    int sDate = thisYear*10000+thisMonth*100+1;
    int eDate = thisYear*10000+thisMonth*100+END_DATE;

    try{
      out.println(strHtml.printHeader());
      out.println(strHtml.printMenu());
      printMain(out);
      if (cmd.equals("day")){
        DayData ddata = new DayData(thisYear,thisMonth,startYear,endYear,startMonth,endMonth);
        out.println(ddata.printMain());
      }else if (cmd.equals("ip")){
        IPStatistics ips = new IPStatistics(sDate, eDate); 
        out.println(ips.printMain());
      }else if (cmd.equals("ref")){
        REFStatistics rps = new REFStatistics(sDate, eDate); 
        out.println(rps.printMain());
      }else if (cmd.equals("brow")){
        BROWStatistics brows = new BROWStatistics(sDate, eDate); 
        out.println(brows.printMain());
      }else if (cmd.equals("os")){
        OSStatistics oss = new OSStatistics(sDate, eDate); 
        out.println(oss.printMain());
      }
      out.println(strHtml.printBottom());
    }catch(ErrException e){
      out.println(e.errMessage());
    }catch(Exception ex){
      try{
        throw new ErrException("Day.java","doGet","ĶͰ null̰ų ùٸ ʽϴ.<BR>"+ex.getMessage(),"Exception");
      }catch(ErrException err){
        out.println(err.errMessage());
      }
    }
  }

  private void printMain(PrintWriter out){
    out.println("  <tr>");
    out.println("    <td colspan=2 align=center>");
    out.println("      <table width=480 cellspacing=0 cellpadding=0 border=0>");
    out.println("        <TR><TD width=180 valign=top><B>Daily statistics</b></TD>");
    out.println("        <TD width==300 align=right><a href='/servlet/CountDay?cmd=ip&thisYear="+thisYear+"&thisMonth="+thisMonth+"'><img src='/kcount/images/ip.gif' border=0></a>  <a href='/servlet/CountDay?cmd=ref&thisYear="+thisYear+"&thisMonth="+thisMonth+"'><img src='/kcount/images/ref.gif' border=0></a> <a href='/servlet/CountDay?cmd=brow&thisYear="+thisYear+"&thisMonth="+thisMonth+"'><img src='/kcount/images/brow.gif' border=0></a> <a href='/servlet/CountDay?cmd=os&thisYear="+thisYear+"&thisMonth="+thisMonth+"'><img src='/kcount/images/os.gif' border=0></a></TD></TR>");
    out.println("      </TABLE>");
  }
}