/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import kr.pe.kkaok.util.Function;
import kr.pe.kkaok.common.ErrException;

public class DayData {
  private int thisYear;
  private int thisMonth;
  private int startYear;
  private int endYear;
  private int startMonth;
  private int endMonth;
  private PlotData data;
  
  public DayData(int thisYear,int thisMonth,int startYear,int endYear,int startMonth,int endMonth) throws ErrException{
    this.thisYear  = thisYear;    
    this.thisMonth = thisMonth;    
    this.startYear = startYear;    
    this.endYear   = endYear;    
    this.startMonth= startMonth;    
    this.endMonth  = endMonth;    
    data = new PlotData();
    getDailyData();
  }

  public String printMain(){
    int thisMonthCnt  = data.total();
    int maxDayCnt     = data.maxValue();   
    String maxDayName = data.maxLabelStr();
    int avg = data.avgValue();
    StringBuffer html = new StringBuffer();
    html.append("      <table cellspacing=0 cellpadding=3 border=0>\n");
    html.append("        <TR height=10><TD colspan=2></TD></TR>\n");
    html.append("        <tr height=20>\n");
    html.append("          <td width=200 align=right><b>Total [ "+thisYear+"Ҵ "+thisMonth+" ] : </b></td>\n");
    html.append("          <td width=200>"+thisMonthCnt+" hits </td>\n");
    html.append("        </TR>\n");
    html.append("        <tr height=20 >\n");
    html.append("          <td align=right width=200><b>Max [ "+maxDayName+" ] : </b></td>\n");
    html.append("          <td width=200>"+maxDayCnt+" hits ["+(int)((float)((float)maxDayCnt/(float)thisMonthCnt)*100)+"%]</td>\n");
    html.append("        </TR>\n");
    html.append("        <tr height=20 >\n");
    html.append("          <td align=right width=200><b>Avg : </b></td>\n");
    html.append("          <td width=200>"+avg+" hits</td>\n");
    html.append("        </TR>\n");
    html.append("        <TR height=10><TD colspan=2></td></tr>\n");
    html.append("      </table>\n");
    html.append("      <table width=100% cellspacing=0 cellpadding=1>\n");
    html.append("        <tr height=20><td colspan=2><b>Day graph</b></td>\n");
    html.append("        <tr height=20><td colspan=2> \n");
    for (int i = endYear; i >= startYear; i--) {
      if(thisYear==i){
        html.append("<font style='color:#FFC000;font-family:ü'>"+i+"Ҵ</font> | ");
      }else{
        if(thisYear > i){
          html.append("<a href='/servlet/kr.pe.kkaok.mycount.Day?thisYear="+i+"&thisMonth=12'>"+i+"Ҵ</a> | ");
        }else{
          html.append("<a href='/servlet/kr.pe.kkaok.mycount.Day?thisYear="+i+"&thisMonth=1'>"+i+"Ҵ</a> | ");
        }
      }
    }
    html.append("          </td></TR>\n");
    html.append("        <tr height=20><td colspan=2>\n");
    for (int k = startMonth; k <= endMonth; k++) {
      if(thisMonth==k){
      html.append("<font style='color:#FFC000;font-family:ü'>"+k+"</font> | ");
      } else{
      html.append("<a href='/servlet/kr.pe.kkaok.mycount.Day?thisYear="+thisYear+"&thisMonth="+k+"'>"+k+"</a> | ");
      }
    }
    
    html.append("          </td></TR>\n");
    html.append("        <TR bgcolor=#dddddd height=1><TD colspan=2></TD></TR>\n");
    html.append("        <TR height=10><TD colspan=2></TD></TR>\n");
    String getDate    = ""; 
    int    getDateCnt = 0;
    for (int q = 0; q < data.size(); q++) {
      getDate    = data.elementAt(q).label;
      getDateCnt = data.elementAt(q).value; 
      if(getDateCnt== maxDayCnt){
        html.append("<TR><TD width='15%' align=center>"+getDate+"</TD><TD><img src='/kcount/images/graph.gif' height=10 width="+(int)((float)getDateCnt/(float)maxDayCnt*65)+"% ><span style='font-size:7pt;'>&nbsp;( "+(int)((float)getDateCnt/(float)thisMonthCnt*100)+"% <b>"+getDateCnt+"</b> hits <font color=red>max</font>)</span></TD></TR>\n"); 
      } else{
        html.append("<TR><TD width='15%' align=center>"+getDate+"</TD><TD><img src='/kcount/images/graph.gif' height=10 width="+(int)((float)getDateCnt/(float)maxDayCnt*65)+"% ><span style='font-size:7pt;'>&nbsp;( "+(int)((float)getDateCnt/(float)thisMonthCnt*100)+"% <b>"+getDateCnt+"</b> hits )</span></TD></TR>\n"); 
      }
    }
    return html.toString();
  }

  public void getDailyData() throws ErrException
  {
    int startband  = (thisYear*10000)+(thisMonth*100);
    int endband    = (thisYear*10000)+(thisMonth*100)+99;
    String sql = "select count(idx) cnt,cdate from kcount where (cdate >?) and (cdate <?) Group by cdate";
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    Connection conn = null;
    try{
      conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn.prepareStatement(sql);
      pstmt.setInt(1,startband);
      pstmt.setInt(2,endband);
      rs = pstmt.executeQuery();
      while(rs.next()){
        DataItem d = new DataItem(rs.getString("cdate").substring(6,8)+"#"+rs.getString("cnt"));         
        data.addElement(d);           
      }  
    } catch (SQLException se) {
      throw new ErrException("Day.java","getDailyCnt","¥ ī͸ ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Day.java","getDailyCnt","¥ ī͸ ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}
      try{if (conn!=null) conn.close();}catch(SQLException se){}
    }
  }
}  
