/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.util;

import java.util.*;
import javax.servlet.http.*;
import java.text.*;

public class Function {

  private String errMsg = null;
  
  public static String encodeHTMLSpecialChar(String str,int n) {
    switch (n){
      case 1 : // text mode db Է
               str = rplc(str,"<","&lt;");
               str = rplc(str,"\"","&quot;");
      break;
      case 2 : // html mode db Է
               str = rplc(str,"<sc","<x-sc");
               str = rplc(str,"<title","<x-title");
      break;
      case 11: // text ϶ CONENT ó
               str = rplc(str," ","&nbsp;");
               str = rplc(str,"\n","<br>");
      break;
      case 13: // comment  ϶
               str = rplc(str,"\n","<br>");
      break;
    } 
  return str;
  }

  public static String rplc(String mainString, String oldString, String newString) { 
    if (mainString == null) {
     return null;
    }
    if (oldString == null || oldString.length() == 0) {
     return mainString;
    }
    if (newString == null) {
     newString = "";
    }
    
    int i = mainString.lastIndexOf(oldString);
    if (i < 0)return mainString;
    StringBuffer mainSb = new StringBuffer(mainString);
    while (i >= 0) {
      mainSb.replace(i, (i + oldString.length()), newString);
      i = mainString.lastIndexOf(oldString, i - 1);
    }
    return mainSb.toString();
  }

  public static String searchWord(String strSubject,int flag,String seaName,String colName,String strKeyword){
    String alterKey = "<font color=red>" + strKeyword + "</font>" ;
    if ((flag == 1) && (seaName.equals(colName))){
      alterKey = rplc(strSubject,strKeyword,alterKey);
    }else{
      alterKey = strSubject;
    }
    return alterKey;
  }

  public static void setCookie(HttpServletResponse response, String name, String value) {
    value = java.net.URLEncoder.encode(value);
    Cookie cookie = new Cookie(name, value);
    cookie.setMaxAge(60*60*24*3000);
    response.addCookie(cookie);
  }

  public static void setCookie(HttpServletResponse response, String name, String value,String uri) {
    value = java.net.URLEncoder.encode(value);
    Cookie cookie = new Cookie(name, value);
    cookie.setPath(uri);
    cookie.setMaxAge(60*60*24*3000);
    response.addCookie(cookie);
  }

  public static String getCookie(HttpServletRequest request, String cookieName) {
    Cookie [] cookies = request.getCookies();
    String value = "";
    for(int i=0;i<cookies.length;i++) {
      if(cookieName.equals(cookies[i].getName())) {
        value = java.net.URLDecoder.decode(cookies[i].getValue());
      break;
      }
    }
    return value;
  }

  public static String getReqParameter(String Req,String ifNulltoReplace ) {
    if ( Req == null || Req.equals("")) return ifNulltoReplace;
    else return Req.trim();
    
  }

  public static String getReqParameter(String Req ) {
    if (Req == null || Req.equals("")) return "";
    else               return Req.trim();
    
  }

  public static int getIntParameter(String Req,int ifNulltoReplace ) {
    try {
      if ( Req == null || Req.equals("")) return ifNulltoReplace;
      else               return Integer.parseInt(Req.toString());
    }catch(NumberFormatException e){
      return ifNulltoReplace;
    }
  }

  public static int getIntParameter(String Req ) {
    try {
      if (Req == null || Req.equals("")) return 0;
      else               return Integer.parseInt(Req.toString());
    }catch(NumberFormatException e){
      return 0;
    }
  }

  public static String returnURL(String rurl, String alertMessage) {
    String rHtml = new String(" ");

    if ( alertMessage == null || alertMessage.equals("") ) return "";
    rHtml  = "<script language=javascript>\n " +
             "<!-- \n" +
             "alert('" + alertMessage.trim() + "'); \n" +
             "document.location.href='" + rurl + "';  \n" +
             "// --> \n" +
             "</script> \n";
  return rHtml;
  }

  public static String returnHistory(String alertMessage) {
    String rHtml = "";
    rHtml = "<script language=javascript> \n " +
            "<!-- \n" +
            " alert('"+alertMessage.trim()+"'); \n" +
            " history.back(); \n" +
            "// --> \n" +
            "</script> \n ";
  return rHtml;
  }

  public static String returnClose(String alertMessage) {
    String rHtml = "";
    rHtml = "<script language=javascript> \n " +
            "<!-- \n" +
            " alert('"+alertMessage.trim()+"'); \n" +
            " opener.location.reload(); \n" +
            " window.close(); \n" +
            "// --> \n" +
            "</script> \n ";
  return rHtml;
  }

  public static String returnClose2(String alertMessage) {
    String rHtml = "";
    rHtml = "<script language=javascript> \n " +
            "<!-- \n" +
            " alert('"+alertMessage.trim()+"'); \n" +
            " window.close(); \n" +
            "// --> \n" +
            "</script> \n ";
  return rHtml;
  }

  public static String getFileSize(long filesize) {
  
    DecimalFormat df = new DecimalFormat(".##"); 
    String fSize="";
    if ((filesize > 1024) && (filesize < 1024 * 1024)) {
      fSize = df.format((float)filesize/1024).toString() + " KB" ;
    } else if (filesize >= 1024 * 1024) {
      fSize = df.format((float)filesize/(1024*1024)).toString() + " MB" ;
    } else {
      fSize = Long.toString(filesize) + " Bytes" ;
    }
    return fSize;
  }

  public static String getTitleLimit(String title,int maxNum,int re_level) {
    int blankLen = 0;
    if(re_level != 0){
      blankLen = (re_level +1)*2;
    }
    int tLen =title.length();
    int count = 0;  
    char c;
    int s=0;
    for(s=0;s<tLen;s++){
      c = title.charAt(s);
      if((int)(count) > (int)(maxNum-blankLen)){
        break;
      }
      
      if(c>127) count +=2 ;
      else count ++;
    }     
    return (tLen >s)? title.substring(0,s)+"..." : title;
  }
  
  public static String getReImg(int level,int t) {
         int wid = t*level;
         return (level > 0)? "<img src='/kBoard/images/sp.gif' width="+wid+" height='5' border=0><img src='/kBoard/images/re.gif' border=0>" : "";
  }

  public static String getEmailnName(String email,String name) {
         return (email == "")? name:"<a href='mailto:"+email+"'>"+name+"</a>";
  }

  public static String getEmai2Name2Home(String e,String name,String h) {
         String returnValue = name;
         if(!h.equals("")) {
           if(h.indexOf("http://")>-1) returnValue += " <a href='"+h+"' target=_blank><img src='/kBoard/images/home.gif' border=0></a>";
           else returnValue += " <a href='http://"+h+"' target=_blank><img src='/kBoard/images/home.gif' border=0></a>";
         }
         if(!e.equals("")) returnValue += " <a href='mailto:"+e+"'><img src='/kBoard/images/email.gif' border=0></a>";
         return returnValue ; 
  }

  public static String getNum(int level,int ref) {
         return (level > 0)? "&nbsp;" : Integer.toString(ref);
  }

  public static String getChecked(String s,String word) {
         return s.equals(word) ? "checked" : "";
  }

  public static String getSelected(String s,String word) {
         return s.equals(word) ? "selected" : "";
  }

  public static String getChecked(int s,int w) {
         return (s==w)? "checked" : "";
  }

  public static String getSelected(int s,int w) {
         return (s==w)? "selected" : "";
  }

  public static String getCurrent(int i,int ri) {
         return (i == ri)? "<font color='red'></font>" : "&nbsp;";
  }

  public static String get2NumFormat(int t){
         String returnNum = Integer.toString(t);
         if (returnNum.length() > 1) return returnNum;
         else                return "0"+returnNum;
  }

  public static int getTotal(int rc,int ps){
         int t = (int)((rc-1)/ps)+1;
         if(t == 0) t = 1 ;
         return t; 
  }
}
