/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import kr.pe.kkaok.util.Function;
import kr.pe.kkaok.common.ErrException;

public class IpnAgent extends HttpServlet {
  private int thisYear     = 0 ;
  private int thisMonth    = 0 ;
  private int thisDate     = 0 ;
  private int gotoPage     = 0 ;
  private int SINCE_YEAR;
  private int SINCE_MONTH;
  private int SINCE_DATE;
  private int NOW_YEAR;
  private int NOW_MONTH;
  private int NOW_DATE;

  public void init(ServletConfig config) throws javax.servlet.ServletException {
    super.init(config);
    ResourceBundle bundle = null;
    try {
        bundle = ResourceBundle.getBundle("URL");
        SINCE_YEAR  = Integer.parseInt(bundle.getString("SINCE_YEAR").toString());
        SINCE_MONTH = Integer.parseInt(bundle.getString("SINCE_MONTH").toString());
        SINCE_DATE  = Integer.parseInt(bundle.getString("SINCE_DATE").toString());
    } catch (Exception e) {
        System.out.println("Err: "+e.toString());
    }
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  {
    response.setContentType("text/html; charset=EUC-KR");
    PrintWriter out   = null; 
    try{ 
      out = response.getWriter();
    }catch(IOException ie){}    
    CountHtmlForm strHtml = new CountHtmlForm();

    Calendar now= Calendar.getInstance();
    NOW_YEAR    = now.get(Calendar.YEAR);
    NOW_MONTH   = now.get(Calendar.MONTH) + 1;
    NOW_DATE    = now.get(Calendar.DATE);

    String cmd = Function.getReqParameter(request.getParameter("cmd"),"agent");
    thisYear  = Function.getIntParameter(request.getParameter("thisYear"),NOW_YEAR);
    thisMonth = Function.getIntParameter(request.getParameter("thisMonth"),NOW_MONTH);
    thisDate  = Function.getIntParameter(request.getParameter("thisDate"),NOW_DATE);
    gotoPage  = Function.getIntParameter(request.getParameter("gotoPage"),1);

    int sDate = thisYear*10000+thisMonth*100+thisDate;
    int eDate = sDate;

    try{
      out.println(strHtml.printHeader());
      out.println(strHtml.printMenu());
      printHeader(out);
      printMain(out);
      if (cmd.equals("agent")){
        IpnAgentData idata = new IpnAgentData(thisYear,thisMonth,thisDate,gotoPage);
        out.println(idata.getInfoData());
      }else if (cmd.equals("ip")){
        IPStatistics ips = new IPStatistics(sDate, eDate); 
        out.println(ips.printMain());
      }else if (cmd.equals("ref")){
        REFStatistics rps = new REFStatistics(sDate, eDate); 
        out.println(rps.printMain());
      }else if (cmd.equals("brow")){
        BROWStatistics brows = new BROWStatistics(sDate, eDate); 
        out.println(brows.printMain());
      }else if (cmd.equals("os")){
        OSStatistics oss = new OSStatistics(sDate, eDate); 
        out.println(oss.printMain());
      }
      out.println(strHtml.printBottom());
    }catch(ErrException e){
      out.println(e.errMessage());
    }catch(Exception ex){
      try{
        throw new ErrException("IpnAgent.java","doGet","ĶͰ null̰ų ùٸ ʽϴ.<BR>"+ex.getMessage(),"Exception");
      }catch(ErrException err){
        out.println(err.errMessage());
      }
    }
  }

  private void printHeader(PrintWriter out){    
    out.println("<script language=javascript src='/kcount/inc/js/count.js'></script>");
  }

  private void printMain(PrintWriter out){    
    out.println("  <tr>");
    out.println("    <td colspan=2 align=center>");
    out.println("      <table width=480 cellspacing=0 cellpadding=0 border=0>");
    out.println("        <TR><TD width=180 valign=top><B>Daily IP & Agent Statics</b></TD>");
    out.println("        <TD width==300 align=right><a href='/servlet/CountIpnAgent?cmd=ip&thisYear="+thisYear+"&thisMonth="+thisMonth+"&thisDate="+thisDate+"'><img src='/kcount/images/ip.gif' border=0></a> <a href='/servlet/CountIpnAgent?cmd=ref&thisYear="+thisYear+"&thisMonth="+thisMonth+"&thisDate="+thisDate+"'><img src='/kcount/images/ref.gif' border=0></a> <a href='/servlet/CountIpnAgent?cmd=brow&thisYear="+thisYear+"&thisMonth="+thisMonth+"&thisDate="+thisDate+"'><img src='/kcount/images/brow.gif' border=0></a> <a href='/servlet/CountIpnAgent?cmd=os&thisYear="+thisYear+"&thisMonth="+thisMonth+"&thisDate="+thisDate+"'><img src='/kcount/images/os.gif' border=0></a></TD></TR>");
    out.println("      </TABLE>");
  }
}