/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import kr.pe.kkaok.util.Function;
import kr.pe.kkaok.common.ErrException;

public class IpnAgentData {

  private int thisYear;
  private int thisMonth;
  private int thisDate;
  private int gotoPage;
  private int cmakeToday    = 0 ;
  private int prevYear      = 0 ;
  private int prevMonth     = 0 ;
  private int prevNowdate   = 0 ;
  private int nextYear      = 0 ;
  private int nextMonth     = 0 ;
  private int nextNowdate   = 0 ;
  private int totalSum      = 0 ;
  private int pageSize      = 20 ;
  private int totalPage     = 0 ;
  private StringBuffer html = new StringBuffer();
  
  public IpnAgentData(int thisYear,int thisMonth,int thisDate,int gotoPage) throws ErrException{
    this.thisYear  = thisYear;    
    this.thisMonth = thisMonth;    
    this.thisDate  = thisDate;    
    this.gotoPage  = gotoPage;    
    setPrevNextDate();
  }

  public void setPrevNextDate(){
    Calendar c1 = Calendar.getInstance();
    Calendar c2 = Calendar.getInstance();
    Calendar c3 = Calendar.getInstance();
    c1.set(thisYear,thisMonth-1,thisDate);
    int cyear      = c1.get(Calendar.YEAR);
    int cmonth     = c1.get(Calendar.MONTH) + 1;
    int cnowdate   = c1.get(Calendar.DATE);
    cmakeToday     = (cyear*10000)+(cmonth*100)+cnowdate;

    c2.set(thisYear,thisMonth-1,thisDate-1);
    prevYear    = c2.get(Calendar.YEAR);
    prevMonth   = c2.get(Calendar.MONTH) + 1;
    prevNowdate = c2.get(Calendar.DATE);
   
    c3.set(thisYear,thisMonth-1,thisDate+1);
    nextYear    = c3.get(Calendar.YEAR);
    nextMonth   = c3.get(Calendar.MONTH) + 1;
    nextNowdate = c3.get(Calendar.DATE);
  }        

  public String getInfoData() throws ErrException
  {
    totalSum = getTotalSum();
    totalPage = Function.getTotal(totalSum,pageSize);
    if(gotoPage > totalPage) gotoPage = totalPage;
    printMain();
    getInfo();
    printBottom();
    return html.toString(); 
  }

  public void printMain(){    
    html.append("      <table width=480 cellspacing=0 cellpadding=0 border=0>\n");
    html.append("      <form name='myform'>\n");
    html.append("       <tr><td colspan=3 align=right><b>"+thisYear+"Ҵ "+thisMonth+" "+thisDate+"</b></td></tr>\n");
    html.append("        <TR><td width=100>Today, <b>"+totalSum+"</b> visited &nbsp;</td><TD align=center>Year<input type='text' name='thisYear' size=4> Month <input type='text' name='thisMonth' size=2> Day <input type='text' name='thisDate' size=2> <img src='/kcount/images/go.gif' border=0 style='cursor:hand' onclick='sendit()'></TD>\n");
    html.append("           <td width=100 align=right><img src='/kcount/images/prev.gif' border=0 style='cursor:hand' onclick='go("+prevYear+","+prevMonth+","+prevNowdate+")'> <img src='/kcount/images/next.gif' border=0 style='cursor:hand' onclick='go("+nextYear+","+nextMonth+","+nextNowdate+")'></td></tr>\n");
    html.append("           <input type='hidden' name='gotoPage'>\n");
    html.append("      </form></TABLE>\n");
    html.append("      <table width=100% cellspacing=0 cellpadding=1 border=0>\n");
    html.append("        <tr height=10><td colspan=5></td></TR>\n");
    html.append("        <TR bgcolor=#dddddd height=1><TD colspan=5></TD></TR>\n");
    html.append("        <TR height=2><TD colspan=5></TD></TR>\n");
    html.append("        <TR>\n");
    html.append("          <TD width=40 ALIGN=CENTER>TIME</TD>\n");
    html.append("          <TD width=90 ALIGN=CENTER>IP</TD>\n");
    html.append("          <TD width=190 ALIGN=CENTER>REFERER</TD>\n");
    html.append("          <TD width=50 ALIGN=CENTER>BROWSER</TD>\n");
    html.append("          <TD width=100 ALIGN=CENTER>OS</TD>\n");
    html.append("        </TR>\n");
    html.append("        <TR height=2><TD colspan=5></TD></TR>\n");
    html.append("        <TR bgcolor=#dddddd height=1><TD colspan=5></TD></TR>\n");
  }

  public void printBottom(){  
    MovePageCount mp   = new MovePageCount();
    html.append("        <TR height=10><TD colspan=5></TD></TR>\n");
    html.append("        <TR bgcolor=#dddddd height=1><TD colspan=5></TD></TR>\n");
    html.append("      </table>\n");
    html.append("      <table cellpadding=0 cellspacing=0 border=0 width=100% >\n");
    html.append("        <tr height=25><td align=center>"+mp.pageDivision(totalPage,10,gotoPage,thisYear,thisMonth,thisDate)+"</td></tr>\n");
  }

  public int getTotalSum() throws ErrException
  {
    int returnValue = 0;
    String sql = "select count(idx) cnt from kcount where (cdate = ?)";
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    Connection conn = null;
    try{
      conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn.prepareStatement(sql);
      pstmt.setInt(1,cmakeToday);
      rs = pstmt.executeQuery();
      if(rs !=null && rs.next()) {
        returnValue = rs.getInt("cnt");
      }  
    } catch (SQLException se) {
      throw new ErrException("IpnAgent.java","getTotalSum","ش糯¥ հ踦 ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("IpnAgent.java","getTotalSum","ش糯¥ հ踦 ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
      try{if (conn!=null) conn.close();}catch(SQLException se){}
    }
    return returnValue;
  }

  public void getInfo() throws ErrException
  {
    String ctime   = "";
    String ip      = "";
    String referer = "";
    String browser = "";
    String os      = "";
    String alterTime   = "";
    String linkReferer = "";
    int trimStart  = 0;
    int trimEnd    = 0;
    String query   = "select ctime,ip,referer,browser,os from kcount where (cdate = ?) order by idx desc limit ?,?";
 
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    Connection conn = null;
    try{
      conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn.prepareStatement(query);
      pstmt.setInt(1,cmakeToday);
      pstmt.setInt(2,(gotoPage-1)*pageSize);
      pstmt.setInt(3,pageSize);
      rs = pstmt.executeQuery();
      while(rs.next()){
        ctime = Function.getReqParameter(rs.getString("ctime"),"00");
        ip = Function.getReqParameter(rs.getString("ip"));
        referer = Function.getReqParameter(rs.getString("referer"));
        browser = Function.getReqParameter(rs.getString("browser"));
        os = Function.getReqParameter(rs.getString("os"));
        
        if(ctime.length() == 3) alterTime = "0"+ctime;
        else if(ctime.length() == 2) alterTime = "00"+ctime;
        else if(ctime.length() == 1) alterTime = "000"+ctime; 
        else alterTime = ctime;
        alterTime = alterTime.substring(0,2)+":"+alterTime.substring(2,4);
        
        linkReferer = referer;
        trimStart = referer.indexOf("http://");
        if(trimStart != -1) referer = referer.substring(trimStart+7);  
        trimEnd = referer.indexOf("/");
        if(trimEnd != -1) referer = "http://"+referer.substring(0,trimEnd);  

        html.append("        <TR>\n");
        html.append("          <TD>"+alterTime+"</TD>\n");
        html.append("          <TD>"+ip+"</TD>\n");
        html.append("          <TD><a href='"+linkReferer+"' target=_blank class='ref'>"+referer+"</a></TD>\n");
        html.append("          <TD>"+browser+"</TD>\n");
        html.append("          <TD style='padding-left:5'>"+os+"</TD>\n");
        html.append("        </TR>\n");
      }  
    } catch (SQLException se) {
      throw new ErrException("IpnAgent.java","getInfo"," Ʈ ҷ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("IpnAgent.java","getInfo"," Ʈ ҷ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
      try{if (conn!=null) conn.close();}catch(SQLException se){}
    }
  }
}  
