/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import kr.pe.kkaok.util.Function;
import kr.pe.kkaok.common.ErrException;

public class MonthData {
  private int thisYear;
  private int startYear;
  private int endYear;
  private int startMonth;
  private int endMonth;
  private PlotData data;
  
  public MonthData(int thisYear,int startYear,int endYear,int startMonth,int endMonth) throws ErrException{
    this.thisYear  = thisYear;    
    this.startYear = startYear;    
    this.endYear   = endYear;    
    this.startMonth= startMonth;    
    this.endMonth  = endMonth;    
    data = new PlotData();
    getMonthData();
  }

  public String printMain(){    
    int thisYearCnt  = data.total();
    int maxMonthCnt  = data.maxValue();   
    String maxMonthDate = data.maxLabelStr();
    int avg = data.avgValue();
    StringBuffer html = new StringBuffer();
    html.append("        <table cellspacing=0 cellpadding=3 border=0>\n");
    html.append("          <TR height=10><TD colspan=2></TD></TR>\n");
    html.append("          <tr height=20>\n");
    html.append("            <td width=200 align=right><b>Total [ "+thisYear+"Ҵ ] : </b></td>\n");
    html.append("            <td width=200>"+thisYearCnt+" hits</td>\n");
    html.append("          </TR>\n");
    html.append("          <tr height=20>\n");
    html.append("            <td width=200 align=right><b>Max [ "+maxMonthDate+" ] : </b></td>\n");
    html.append("            <td width=200>"+maxMonthCnt+" hits ["+(int)((maxMonthCnt*100)/thisYearCnt)+"%]</td>\n");
    html.append("          </TR>\n");
    html.append("          <tr height=20>\n");
    html.append("            <td width=200 align=right><b>Avg : </b></td>\n");
    html.append("            <td width=200>"+avg+" hits</td>\n");
    html.append("          </TR>\n");
    html.append("          <TR height=10><TD colspan=2></td></tr></table>\n");
    html.append("       <table width=100% cellspacing=0 cellpadding=1>\n");
    html.append("          <tr height=20><td colspan=2><b>Month graph</b></td>\n");
    html.append("          <tr height=20><td colspan=2>\n");
    for (int i = endYear; i >= startYear; i--) {
      if(thisYear==i){
        html.append("<font style='color:#FFC000;font-family:ü'>"+i+"Ҵ</font> | ");
      }else{
        html.append("<a href='/servlet/kr.pe.kkaok.mycount.Month?thisYear="+i+"'>"+i+"Ҵ</a> | ");
      }
    }
    html.append("           </td></TR>\n");
    html.append("         <TR bgcolor=#dddddd height=1><TD colspan=2></TD></TR>\n");
    html.append("         <TR height=10><TD colspan=2></TD></TR>\n");
    String getMonth = ""; 
    int getMonthCnt = 0;
    for (int q = 0; q < data.size(); q++) {
      getMonth    = data.elementAt(q).label;
      getMonthCnt = data.elementAt(q).value; 
      if(getMonthCnt == maxMonthCnt){
        html.append("<TR><TD width=15% align=center>"+getMonth+"</TD><TD><img src='/kcount/images/graph.gif' height=10 width="+(int)(((float)getMonthCnt/(float)maxMonthCnt)*65)+"% ><span style='font-size:7pt;'>&nbsp;( "+(int)(((float)getMonthCnt/(float)thisYearCnt)*100)+"% <b>"+getMonthCnt+"</b> hits <font color=red>max</font>)</span></TD></TR>\n"); 
      }else{
        html.append("<TR><TD width=15% align=center>"+getMonth+"</TD><TD><img src='/kcount/images/graph.gif' height=10 width="+(int)(((float)getMonthCnt/(float)maxMonthCnt)*65)+"% ><span style='font-size:7pt;'>&nbsp;( "+(int)(((float)getMonthCnt/(float)thisYearCnt)*100)+"% <b>"+getMonthCnt+"</b> hits )</span></TD></TR>\n"); 
      }
    }
    return html.toString();
  }
 
  public void getMonthData() throws ErrException
  {
    String sql = "";
    int nextMonthDate   = 0;
    int prevMonthDate   = 0;
    int monthCnt        = 0;
    int tmpMonthCnt     = 0;
    int tmpPrevMonthCnt = 0;
    int prevYearCnt = getPrevYearCnt();
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    for(int k = startMonth;k<=endMonth;k++){
      nextMonthDate = (thisYear*10000)+((k+1)*100);
      prevMonthDate = (thisYear*10000)+((k)*100);
      sql = "select max(idx) cnt from kcount where (cdate >?) and (cdate <?)";
      Connection conn = null;
      try{
        conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
        pstmt = conn.prepareStatement(sql);
        pstmt.setInt(1,prevMonthDate);
        pstmt.setInt(2,nextMonthDate);
        rs = pstmt.executeQuery();
        if(rs !=null && rs.next()) {
          tmpMonthCnt = rs.getInt("cnt");
          if(k==startMonth) monthCnt = tmpMonthCnt - prevYearCnt;
          else monthCnt = tmpMonthCnt - tmpPrevMonthCnt; 
          tmpPrevMonthCnt = tmpMonthCnt;
          DataItem d = new DataItem(Integer.toString(k)+"#"+Integer.toString(monthCnt));         
          data.addElement(d);           
        }
      } catch (SQLException se) {
        throw new ErrException("Month.java","getMonthlyCnt"," ī͸ ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
      } catch (Exception e) {
        throw new ErrException("Month.java","getMonthlyCnt","ü ī͸ ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
      }finally{
        if (rs!=null) try{rs.close();}catch(Exception se){}  
        if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
        try{if (conn!=null) conn.close();}catch(SQLException se){}
      }
    }  
  }

  public int getPrevYearCnt() throws ErrException
  {
    int returnValueInt = 0;
    int curYear = (thisYear-1)*10000+1231; 
    String sql = "select max(idx) cnt from kcount where (cdate=?)";
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    Connection conn = null;
    try{
      conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn.prepareStatement(sql);
      pstmt.setInt(1,curYear);
      rs = pstmt.executeQuery();
      if(rs !=null && rs.next()) {
         returnValueInt = rs.getInt("cnt");
      }
    } catch (SQLException se) {
      throw new ErrException("Month.java","getPrevYearCnt"," 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Month.java","getPrevYearCnt"," 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception e){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception e){}  
      try{if (conn!=null) conn.close();}catch(SQLException se){}
    }
    return returnValueInt;
  }
}  
