/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import kr.pe.kkaok.common.ErrException;
import kr.pe.kkaok.util.Function;
 
public class REFStatistics {
  private int sDate = 0 ;
  private int eDate = 0 ;
  private PlotData data;
   
  public REFStatistics(int sDate, int eDate) throws ErrException{
    this.sDate = sDate;
    this.eDate = eDate;
    data = new PlotData();
    getDataInfo();
  }
    
  public String printMain(){
    int maxYearCnt = data.maxValue();   
    int totalSum   = data.total();
    String getDate = ""; 
    int getDateCnt = 0;
    String sdtemp  = Integer.toString(sDate);
    String edtemp  = Integer.toString(eDate);
    String dateTerm = "";
    if(sDate==eDate){
      dateTerm = sdtemp.substring(0,4) + " " +sdtemp.substring(4,6) + " " +sdtemp.substring(6,8) + "";
    }else{
      dateTerm = sdtemp.substring(0,4) + " " +sdtemp.substring(4,6) + " " +sdtemp.substring(6,8) + " ~ " +edtemp.substring(0,4) + " " +edtemp.substring(4,6) + " " +edtemp.substring(6,8) + "";
    }

    StringBuffer html = new StringBuffer();
    html.append("   <table width=100% cellspacing=0 cellpadding=1>\n");
    html.append("     <TR height=10><TD colspan=2></TD></TR>\n");
    html.append("     <tr style='font-weight: bold;' height=20><td colspan=2>REFERER ["+dateTerm+"]</td></TR>\n");
    html.append("     <TR height=1 bgcolor=#dddddd><TD colspan=2></TD></TR>\n");
    html.append("     <TR height=10><TD colspan=2></TD></TR>\n");
    for (int q = 0; q < data.size(); q++) {
      getDateCnt = data.elementAt(q).value;
      getDate    = Function.getTitleLimit(data.elementAt(q).label,38,0);
      if((getDate != null) && (!getDate.equals(""))){ 
        html.append("<TR><TD width=250 align=right><a href='"+data.elementAt(q).label+"' target=_blank>"+getDate+"</a>&nbsp;</TD><TD width=230><img src='/kcount/images/graph.gif' height=10 width="+(int)(((float)getDateCnt/(float)maxYearCnt)*80)+"% ><span style='font-size:7pt;'> <b>"+getDateCnt+"</b></span></TD></TR>\n"); 
      }
    }
    return html.toString();
  }

  public void getDataInfo() throws ErrException
  {
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    String query = "select referer, count(idx) cnt from kcount where (cdate >=?) and (cdate <=?) group by referer order by cnt desc limit 0,50";
    String exceptionvalue = "";
    Connection conn = null;
    try{
      conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn.prepareStatement(query);
      pstmt.setInt(1,sDate);
      pstmt.setInt(2,eDate);
      rs = pstmt.executeQuery();
      while(rs.next()){
        exceptionvalue = rs.getString("referer");
        if ((exceptionvalue!=null) && (!exceptionvalue.equals(""))){
          DataItem d = new DataItem(exceptionvalue+"#"+rs.getString("cnt"));         
          data.addElement(d);
        }
      }
    } catch (SQLException se) {
      throw new ErrException("REFStatistics.java","getDataInfo","DATA ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("REFStatistics.java","getDataInfo","DATA ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
      try{if (conn!=null) conn.close();}catch(SQLException se){}
    }
  }
}