/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import kr.pe.kkaok.util.Function;
import kr.pe.kkaok.common.ErrException;

public class Statics extends HttpServlet {

  private int makeToday   = 0 ;
  private int makePrevDay = 0 ;
  private int today       = 0 ;
  private int totalSum    = 0 ;
  private int makeTime    = 0 ;
  private int prevDay     = 0 ;
  private int daydiff     = 0 ;
  private int year        = 0 ;
  private int month       = 0 ;
  private int SINCE_YEAR;
  private int SINCE_MONTH;
  private int SINCE_DATE;
  private String SINCE_DAY;
/*
  private int maxDay      = 0 ;
  private String maxDate  = "";
  private String MaxhitsDate = "";
*/  
  public void init(ServletConfig config) throws javax.servlet.ServletException {
    super.init(config);
    ResourceBundle bundle = null;
    try {
        bundle = ResourceBundle.getBundle("URL");
        SINCE_YEAR = Integer.parseInt(bundle.getString("SINCE_YEAR").toString());
        SINCE_MONTH = Integer.parseInt(bundle.getString("SINCE_MONTH").toString());
        SINCE_DATE = Integer.parseInt(bundle.getString("SINCE_DATE").toString());
        SINCE_DAY  = (String)bundle.getString("SINCE_DAY");
    } catch (Exception e) {
        System.out.println("Err: "+e.toString());
    }
  }
  
  public void setDate(){
    DateDiff ddf  = new DateDiff();
    Calendar now  = Calendar.getInstance();
    Calendar yesterday = Calendar.getInstance();
    year          = now.get(Calendar.YEAR);
    month         = now.get(Calendar.MONTH) + 1;
    int nowdate   = now.get(Calendar.DATE);
    int dayofweek = now.get(Calendar.DAY_OF_WEEK);
    makeToday     = (year*10000)+(month*100)+nowdate;
    int hour      = now.get(Calendar.HOUR_OF_DAY);
    int min       = now.get(Calendar.MINUTE);
    makeTime      = (hour*100)+min;

    yesterday.set(year,month-1,nowdate-1);
    int prevYear    = yesterday.get(Calendar.YEAR);
    int prevMonth   = yesterday.get(Calendar.MONTH) + 1;
    int prevNowdate = yesterday.get(Calendar.DATE);
    makePrevDay     = (prevYear*10000)+(prevMonth*100)+prevNowdate;

    daydiff = ddf.dateDiff(SINCE_YEAR,SINCE_MONTH,SINCE_DATE,year,month,nowdate)+1;
  }        

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  {
    response.setContentType("text/html; charset=EUC-KR");
    setDate();
    PrintWriter out   = null; 
    try{ 
      out = response.getWriter();
    }catch(IOException ie){}    
    CountHtmlForm strHtml = new CountHtmlForm();

    try{
      getTotal();
/*        
      if(maxDate.length() >= 8){
        MaxhitsDate = maxDate.substring(0,4)+"-"+maxDate.substring(4,6)+"-"+maxDate.substring(6,8);
      }
*/
      out.println(strHtml.printHeader());
      out.println(strHtml.printMenu());
      printMain(out);
      out.println(strHtml.printBottom());
    }catch(ErrException e){
      out.println(e.errMessage());
    }catch(Exception ex){
      try{
        throw new ErrException("Statics.java","doGet","ĶͰ null̰ų ùٸ ʽϴ.<BR>"+ex.getMessage(),"Exception");
      }catch(ErrException err){
        out.println(err.errMessage());
      }
    }
  }
    
  private void printMain(PrintWriter out)
  {
    out.println("  <tr>");
    out.println("    <td colspan=2 align=center>");
    out.println("   <table width=480 cellpadding=0 cellspacing=0 border=0>");
    out.println("    <TR><TD><B>Total statistics</b></TD></TR>");
    out.println("   </TABLE>");
    out.println("   <table cellspacing=0 cellpadding=3>");
    out.println("      <TR height=10><TD colspan=2></TD></TR>");
    out.println("      <tr height=20>");
    out.println("        <td width=200 align=right><b>Total : </b></td>");
    out.println("        <td width=200>"+totalSum+" hits</td>");
    out.println("      </TR>");
    out.println("      <TR height=10><TD colspan=2></TD></TR>");
    out.println("      <tr height=20>");
    out.println("        <td width=200 align=right><b>Today : </b></td>");
    out.println("        <td width=200>"+today+" hits</td>");
    out.println("        </TR>");
    out.println("      <tr height=20>");
    out.println("        <td width=200 align=right><b>Yesterday : </b></td>");
    out.println("        <td width=200>"+prevDay+" hits</td>");
    out.println("      </TR>");
/*
    out.println("      <TR height=10><TD colspan=2></TD></TR>");
    out.println("      <tr height=20>");
    out.println("        <td width=200 align=right><b>Max hit (per day) : </b></td>");
    out.println("        <td width=200>"+maxDay+" hits ["+MaxhitsDate+"]</td>");
    out.println("      </TR>");
*/
    out.println("      <tr height=20>");
    out.println("        <td width=200 align=right><b>Avg hit (per day) : </b></td>");
    out.println("        <td width=200>"+(int)(totalSum/daydiff)+" hits</td>");
    out.println("      </TR>");
    out.println("      <TR height=10><TD colspan=2></TD></TR>");
    out.println("      <tr height=20>");
    out.println("        <td width=200 align=right><b>Since : </b></td>");
    out.println("        <td width=200>"+SINCE_YEAR+"-"+SINCE_MONTH+"-"+SINCE_DATE+" "+SINCE_DAY+"</td>");
    out.println("      </TR>");
    out.println("      <tr height=20>");
    out.println("        <td width=200 align=right><b>How long.... : </b></td>");
    out.println("        <td width=200>"+daydiff+" Days</td>");
    out.println("      </TR>");
  }

  public void getTotal() throws ServletException,ErrException
  {
    totalSum = 0;
    String sql = "";
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    sql = "select idx from kcount order by idx desc limit 0,1";
    Connection conn = null;
    try{
      conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn.prepareStatement(sql);
      rs = pstmt.executeQuery();
      if(rs !=null && rs.next()) {
         totalSum = rs.getInt("idx");
      }
    } catch (SQLException se) {
      throw new ErrException("Statics.java","getTotal","ü 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Statics.java","getTotal","ü 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
      try{if (conn!=null) conn.close();}catch(SQLException se){}
    }

    sql = "select count(idx) todayIdx from kcount where cdate= ?";
    Connection conn2 = null;
    try{
      conn2 = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn2.prepareStatement(sql);
      pstmt.setInt(1,makeToday);
      rs = pstmt.executeQuery();
      if(rs !=null && rs.next()) {
         today    = rs.getInt("todayIdx");
      }
    } catch (SQLException se) {
      throw new ErrException("Statics.java","getTotal","ü 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Statics.java","getTotal","ü 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
      try{if (conn2!=null) conn2.close();}catch(SQLException se){}
    }

    sql = "select count(idx) prevDayIdx from kcount where cdate< ? and cdate >= ?";
    Connection conn3 = null;
    try{
      conn3 = DriverManager.getConnection("jdbc:jdc:jdcpool");
      pstmt = conn3.prepareStatement(sql);
      pstmt.setInt(1,makeToday);
      pstmt.setInt(2,makePrevDay);
      rs = pstmt.executeQuery();
      if(rs !=null && rs.next()) {
         prevDay  = rs.getInt("prevDayIdx");
      }
    } catch (SQLException se) {
      throw new ErrException("Statics.java","getTotal","ü 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Statics.java","getTotal","ü 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
      try{if (conn3!=null) conn3.close();}catch(SQLException se){}
    }
    /*
    sql = "select count(idx) maxIdx,cdate from kcount Group by cdate order by maxIdx desc limit 0,1";
    try {
      pstmt = conn.prepareStatement(sql);
      rs = pstmt.executeQuery();
      if(rs !=null && rs.next()) {
         maxDay   = rs.getInt("maxIdx");
         maxDate  = rs.getString("cdate");
      }
    } catch (SQLException se) {
      throw new ErrException("Statics.java","getTotal","ü 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Statics.java","getTotal","ü 迡  ī͸ ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
    }
    */
  }
}  
