/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import kr.pe.kkaok.common.ErrException;
import kr.pe.kkaok.util.Function;
 
public class Year extends HttpServlet {

  private int SINCE_YEAR;
  private int SINCE_MONTH;
  private int SINCE_DATE;
  private int NOW_YEAR;
  private int NOW_MONTH;
  private int NOW_DATE;
  
  public void init(ServletConfig config) throws javax.servlet.ServletException {
    super.init(config);
    ResourceBundle bundle = null;
    try {
        bundle = ResourceBundle.getBundle("URL");
        SINCE_YEAR  = Integer.parseInt(bundle.getString("SINCE_YEAR").toString());
        SINCE_MONTH = Integer.parseInt(bundle.getString("SINCE_MONTH").toString());
        SINCE_DATE  = Integer.parseInt(bundle.getString("SINCE_DATE").toString());
    } catch (Exception e) {
        System.out.println("Err: "+e.toString());
    }
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  {
    CountHtmlForm strHtml = new CountHtmlForm();
    response.setContentType("text/html; charset=EUC-KR");
    PrintWriter out   = null; 
    try{ 
      out = response.getWriter();
    }catch(IOException ie){}    

    Calendar now= Calendar.getInstance();
    NOW_YEAR    = now.get(Calendar.YEAR);
    NOW_MONTH   = now.get(Calendar.MONTH) + 1;
    NOW_DATE    = now.get(Calendar.DATE);

    String cmd = Function.getReqParameter(request.getParameter("cmd"),"year");
    int sDate = SINCE_YEAR*10000+SINCE_MONTH*100+SINCE_DATE;
    int eDate = NOW_YEAR*10000+NOW_MONTH*100+NOW_DATE;
    
    try{
      out.println(strHtml.printHeader());
      out.println(strHtml.printMenu());
      printMain(out);
      if (cmd.equals("year")){
        YearData ydata = new YearData(SINCE_YEAR,NOW_YEAR);
        out.println(ydata.printMain());
      }else if (cmd.equals("ip")){
        IPStatistics ips = new IPStatistics(sDate, eDate); 
        out.println(ips.printMain());
      }else if (cmd.equals("ref")){
        REFStatistics rps = new REFStatistics(sDate, eDate); 
        out.println(rps.printMain());
      }else if (cmd.equals("brow")){
        BROWStatistics brows = new BROWStatistics(sDate, eDate); 
        out.println(brows.printMain());
      }else if (cmd.equals("os")){
        OSStatistics oss = new OSStatistics(sDate, eDate); 
        out.println(oss.printMain());
      }
      out.println(strHtml.printBottom());
    }catch(ErrException e){
      out.println(e.errMessage());
    }catch(Exception ex){
      try{
        throw new ErrException("Year.java","doGet","ĶͰ null̰ų ùٸ ʽϴ.<BR>"+ex.getMessage(),"Exception");
      }catch(ErrException err){
        out.println(err.errMessage());
      }
    }
  }
    
  private void printMain(PrintWriter out){
    out.println("  <tr>");
    out.println("    <td colspan=2 align=center>");
    out.println("   <table width=480 cellpadding=0 cellspacing=0 border=0>");
    out.println("      <TR><TD width=180 valign=top><B>Yearly statistics</b></TD>");
    out.println("      <TD width==300 align=right><a href='/servlet/CountYear?cmd=ip'><img src='/kcount/images/ip.gif' border=0></a> <a href='/servlet/CountYear?cmd=ref'><img src='/kcount/images/ref.gif' border=0></a> <a href='/servlet/CountYear?cmd=brow'><img src='/kcount/images/brow.gif' border=0></a> <a href='/servlet/CountYear?cmd=os'><img src='/kcount/images/os.gif' border=0></a></TD></TR>");
    out.println("   </TABLE>");
  }
}  
