/*************************************
  Author      : 
  Email       : jack1972@naver.com 
  homepage    : http://www.kkaok.pe.kr
  Created on  : 2002.09.17 
  Description :  
       :
*************************************/
package kr.pe.kkaok.mycount;

import java.io.*;
import java.sql.*;
import java.util.*;
import kr.pe.kkaok.common.ErrException;
 
public class YearData {
  private int SINCE_YEAR;
  private int NOW_YEAR;
  private PlotData data;
  
  public YearData(int SINCE_YEAR,int NOW_YEAR) throws ErrException{
    this.SINCE_YEAR = SINCE_YEAR;    
    this.NOW_YEAR   = NOW_YEAR;    
    data = new PlotData();
    getYearData();
  }

  public void getYearData() throws ErrException
  {
    String sql = "";
    int nextYear = 0;
    int tmpYearCnt = 0;
    int tmpPrevYearCnt = 0;
    int yearCnt = 0;
    ResultSet rs = null;
    PreparedStatement pstmt = null;
    Connection conn = null;
    try{
      conn = DriverManager.getConnection("jdbc:jdc:jdcpool");
      for(int k = SINCE_YEAR;k<=NOW_YEAR;k++){
        nextYear = (k+1)*10000;
        sql = "select max(idx) maxIdx from kcount where cdate <?";
        pstmt = conn.prepareStatement(sql);
        pstmt.setInt(1,nextYear);
        rs = pstmt.executeQuery();
        if(rs !=null && rs.next()) {
          tmpYearCnt = rs.getInt("maxIdx");
          yearCnt    = tmpYearCnt - tmpPrevYearCnt;
          tmpPrevYearCnt = tmpYearCnt;
          DataItem d = new DataItem(Integer.toString(k)+"#"+Integer.toString(yearCnt));         
          data.addElement(d);           
        }
        try{
          if (rs!=null) rs.close();
          if (pstmt!=null) pstmt.close();
        }catch(Exception e){}
      }  
    } catch (SQLException se) {
      throw new ErrException("Year.java","getYear"," ī͸ ϴ   ߻߽ϴ.<BR>"+se.getMessage(),"SQLException");
    } catch (Exception e) {
      throw new ErrException("Year.java","getYear"," ī͸ ϴ   ߻߽ϴ.<BR>"+e.getMessage(),"Exception");
    }finally{
      if (rs!=null) try{rs.close();}catch(Exception se){}  
      if (pstmt!=null) try{pstmt.close();}catch(Exception se){}  
      try{if (conn!=null) conn.close();}catch(SQLException se){}
    }
  }

  public String printMain(){
    int totalSum = data.total();
    int maxYearCnt = data.maxValue();   
    String getDate = ""; 
    int getDateCnt = 0;
    StringBuffer html = new StringBuffer();
    html.append("   <table cellspacing=0 cellpadding=3 border=0>\n");
    html.append("     <TR height=10><TD colspan=2></TD></TR>\n");
    html.append("     <tr height=20>\n");
    html.append("       <td width=200 align=right><b>Total : </b></td>\n");
    html.append("       <td width=200>"+totalSum+" hits</td>\n");
    html.append("     </TR>");
    html.append("     <tr height=20>");
    html.append("        <td width=200 align=right><b>Max : </b></td>\n");
    html.append("        <td width=200>"+maxYearCnt+" hits ["+data.maxLabelStr()+"Ҵ]</td>\n");
    html.append("     </TR>\n");
    html.append("     <tr height=20>\n");
    html.append("        <td width=200 align=right><b>Avg : </b></td>\n");
    html.append("        <td width=200>"+data.avgValue()+" hits</td>\n");
    html.append("     </TR>\n");
    html.append("     <TR height=10><TD colspan=2></td></tr></table>\n");
    html.append("   <table width=100% cellspacing=0 cellpadding=1>\n");
    html.append("     <tr style='font-weight: bold;' height=20><td colspan=2>Year graph</td></TR>\n");
    html.append("     <TR height=1 bgcolor=#dddddd><TD colspan=2></TD></TR>\n");
    html.append("     <TR height=10><TD colspan=2>\n");
    html.append("     <TR height=1><TD colspan=2></TD></TR>\n");
    for (int q = 0; q < data.size(); q++) {
      getDateCnt = data.elementAt(q).value; 
      getDate    = data.elementAt(q).label;
      if(getDateCnt==data.maxValue()){
        html.append("<TR><TD width=50 align=center>"+getDate+"Ҵ</TD><TD><img src='/kcount/images/graph.gif' height=10 width="+(int)(((float)getDateCnt/(float)maxYearCnt)*65)+"% ><span style='font-size:7pt;'>&nbsp;( "+(int)(((float)getDateCnt/(float)totalSum)*100)+"% <b>"+getDateCnt+"</b> hits <font color=red>max</font>)</span></TD></TR>\n"); 
      }else{
        html.append("<TR><TD width=50 align=center>"+getDate+"Ҵ</TD><TD><img src='/kcount/images/graph.gif' height=10 width="+(int)(((float)getDateCnt/(float)maxYearCnt)*65)+"% ><span style='font-size:7pt;'>&nbsp;( "+(int)(((float)getDateCnt/(float)totalSum)*100)+"% <b>"+getDateCnt+"</b> hits )</span></TD></TR>\n"); 
      }
    }
    return html.toString();
  }
}  
